uniform mediump float inner;
uniform mediump float outer;
uniform mediump float strength;
uniform mediump float curvature;
varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
precision mediump float;


void main(void)
{
    mediump vec2 srcOriginSize = srcOriginEnd - srcOriginStart;
    mediump vec2 uv = ((vTex - srcOriginStart) / srcOriginSize);
    vec4 front = texture2D(samplerFront, vTex);
    
    vec2 curve = pow(abs(uv * 2. - 1.), vec2(1. / curvature));
   
    float edge = pow(length(curve), curvature);
    
    float vignette = strength * smoothstep(inner, outer, edge);
    
    gl_FragColor = front * (1. - vignette);
}